;##################################################################
;
;   TesBwan for the TI-86 - miscellaneous routines
;
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   This program is in the public domain.  There is no warranty.
;
;   This file was last updated August 21, 2002.
;
;##################################################################

;############## GET_KEY replacement

SUPER_GET_KEY:
        push    hl
        push    de
        push    bc
        ld      e,0                     ; E = GET_KEY result
        ld      hl,getkeylastdata-1     ; HL = ptr to last read's table
        ld      a,$fe                   ; A = key port mask
        ld      c,0                     ; C = key number counter
gkol:   out     (1),a                   ; select keys to read
        ld      b,8                         
        push    af
        inc     hl
        in      a,(1)                   ; read keyboard data
        ld      d,(hl)                  ; D = previous data
        ld      (hl),a                  ; save current data

        cpl                             ; A = 1 set for pressed keys
        and     d                       ; A = 1 for keys pushed down
        ld      b,8
gkl:    inc     c
        rra                             ; move lowest key into CF
        jr      nc,nokey
        ld      e,c
nokey:  djnz    gkl

        pop     af
        rlca     
        cp      $7F
        jr      nz,gkol
        ld      a,e
        pop     bc
        pop     de
        pop     hl
        ret

CONTRAST_GET_KEY:
        call    SUPER_GET_KEY
        cp      K_PLUS
        jr      z,contplus
        cp      K_MINUS
        ret     nz

contminus:
        ld      hl,CONTRAST
        ld      a,(hl)
        or      a
        ret     z
        dec     a
        ld      (hl),a
        out     (2),a
        xor     a
        ret

contplus:
        ld      hl,CONTRAST
        ld      a,(hl)
        cp      $1f
        jr      z,contdone
        inc     a
        ld      (hl),a
        out     (2),a

contdone:
        xor     a
        ret

getkeylastdata:
        .db     $ff,$ff,$ff,$ff,$ff,$ff,$ff

;############## Addition of A to HL or DE (trashes A)

ADD_HL_A:
        add     a,l
        ld      l,a
        ret     nc
        inc     h
        ret

ADD_DE_A:
        add     a,e
        ld      e,a
        ret     nc
        inc     d
        ret

;############## Division of A by 6
;
; Uses repeated subtraction, so only useful for relatively small values.
; Returns the remainder in A, quotient in C.  Changes B.

DIV_A_6:
        ld      b,6
DIV_A_B:
        ld      c,0
div_loop:
        sub     b
        jr      c,div_done
        inc     c
        jr      div_loop
div_done:
        add     a,b
        ret
